# TravelDiskBackup.ps1
# Copyright 2008, EJ innovations (ej@ejinnovations.com)
#
# This script uses the accompanying script DoBackup.ps1 to perform a robocopy
# backup of a directory tree to an encrypted TrueCrypt volume.  This script ensures the
# volume is mounted before calling DoBackup defined in doBackup.ps1.
#
# This script gets scheduled in Task Scheduler.
#

# first, source in the doBackup script
function Get-ScriptDirectory
{
	$Invocation = (Get-Variable MyInvocation -Scope 1).Value
	Split-Path $Invocation.MyCommand.Path
}
 
$currentDirectory = Get-ScriptDirectory
. $currentDirectory\doBackup.ps1

$trueCryptPath = "c:\program files\TrueCrypt\TrueCrypt.exe";
$target = "t:\backups"
$source = '\\sol\johnsonbackup'
$maxSize = ''
$volume = "\Device\Harddisk1\Partition1"
$keyfile = "c:\windows\system32\TravelDisk.key"
$autoDismount = $TRUE

$targetDrive = $target.SubString(0,2)


$driveInfo = gwmi -query "SELECT * FROM win32_logicaldisk where deviceid = '$targetDrive'"
if ($driveInfo -eq $null)
{
   # drive isn't mounted
   write-host "Drive isn't mounted yet..." 

   # mount with TrueCrypt
   & $trueCryptPath /v $volume /k $keyfile /l $targetDrive /q /s
	sleep 5
}
else
{
   if ([int]$driveInfo["DriveType"] -eq 2)
   {
		throw "Cannot be mounted as Removable Media"
   }
}

# after mounting and before backing up, make sure it exists
if (test-path $target)
{
	DoBackup $source $target $maxSize
	
	if ($autoDismount)
	{
	   & $trueCryptPath /d $targetDrive /q /s
	}
}
else
{
  throw "$target does not exist."
}







